﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Charting;

namespace StackedBar100SL
{
    public partial class MainPage : UserControl
    {
        public class Company
        {
            public double Value1 { get; set; }
            public double Value2 { get; set; }
            public double Value3 { get; set; }
            public DateTime Category { get; set; }
            public Company(DateTime category, double value1, double value2, double value3)
            {
                Category = category;
                Value1 = value1;
                Value2 = value2;
                Value3 = value3;
            }
        } 

        public MainPage()
        {
            InitializeComponent();
            DateTime today = DateTime.Today;
            List<Company> sampleData = new List<Company>();
            sampleData.Add(new Company(today.AddDays(1), 100, 0, 200));
            sampleData.Add(new Company(today.AddDays(2), 210, 210, 100));
            sampleData.Add(new Company(today.AddDays(3), 89, 320, 0));

            SeriesMapping seriesMapping = new SeriesMapping { LegendLabel = "Series 1" };
            seriesMapping.ItemMappings.Add(new ItemMapping("Value1", DataPointMember.YValue));
            seriesMapping.ItemMappings.Add(new ItemMapping("Category", DataPointMember.XCategory));
            SeriesMapping seriesMapping1 = new SeriesMapping { LegendLabel = "Series 2" };
            seriesMapping1.ItemMappings.Add(new ItemMapping("Value2", DataPointMember.YValue));
            seriesMapping1.ItemMappings.Add(new ItemMapping("Category", DataPointMember.XCategory));
            seriesMapping1.SeriesDefinition = new HorizontalStackedBarSeriesDefinition();
            SeriesMapping seriesMapping2 = new SeriesMapping { LegendLabel = "Series 3" };
            seriesMapping2.ItemMappings.Add(new ItemMapping("Value3", DataPointMember.YValue));
            seriesMapping2.ItemMappings.Add(new ItemMapping("Category", DataPointMember.XCategory));

            StackedBarSeriesDefinition horBar = new StackedBarSeriesDefinition();
            seriesMapping2.SeriesDefinition = horBar;
            seriesMapping1.SeriesDefinition = horBar;
            seriesMapping.SeriesDefinition = horBar;
            RadChart1.DefaultView.ChartArea.AxisX.LayoutMode = AxisLayoutMode.Inside;
            RadChart1.ItemsSource = sampleData;

            RadChart1.SeriesMappings.Add(seriesMapping);
            RadChart1.SeriesMappings.Add(seriesMapping1);
            RadChart1.SeriesMappings.Add(seriesMapping2);

            RadChart1.DataBound += (o, e) =>
            {
                foreach (var dataSerie in RadChart1.DefaultView.ChartArea.DataSeries)
                {
                    if (dataSerie != null)
                    {
                        foreach (var point in dataSerie.ToList())
                        {
                            double zeroBar = point.YValue;
                            if (zeroBar == 0)
                            {
                                point.Label = " ";
                            }
                        }
                    }
                }              
            }; 
  
        }        
    }
}
